{============================================================================}
{==                                                                        ==}
{==                            ADD CHEAT Version 1.0                       ==}
{==                   Copyright (C) 1994-96 By The GodFather               ==}
{==                                                                        ==}
{============================================================================}

{$M, 8192,0,655355}

USES Dos,
     GUtils, GMemory, GFDialog;

TYPE
  PCheat      = ^TCheat;
  TCheat      = OBJECT(TObject)
     Name     : PString;
     Line     : LongInt;
     LNum     : Word;
     CONSTRUCTOR Init(aName: STRING; aLine: LongInt; aLNum: Word);
     DESTRUCTOR Done; VIRTUAL;
  END;

  PView       = ^TView;
  TView       = OBJECT(TObject)
        Data  : PString;
        CONSTRUCTOR Init(aData: STRING);
        DESTRUCTOR Done; VIRTUAL;
  END;


VAR
  Database: PCollection;
{  ViewList: PList;
  ViewData: PCollection;
  OldPal  : ARRAY[1..6] OF Byte;}
  FileName: STRING;
  MaxLines: LongInt;


CONSTRUCTOR TCheat.Init(aName: STRING; aLine: LongInt; aLNum: Word);
BEGIN
  Name := NewStr(aName);
  Line := aLine;
  LNum := aLNum;
END;

DESTRUCTOR TCheat.Done;
BEGIN
  DisposeStr(Name);
END;

CONSTRUCTOR TView.Init(aData: STRING);
BEGIN
  IF aData <> ''
    THEN Data := NewStr(aData)
    ELSE Data := NIL;
END;

DESTRUCTOR TView.Done;
BEGIN
  IF Data <> NIL THEN DisposeStr(Data);
END;

FUNCTION Code(St: STRING): STRING;
VAR I: Byte;
  FUNCTION RetRes: Byte; NEAR;
  VAR A: Byte;
  BEGIN
    A := 1;
    IF Odd(I) THEN Inc(A);
    RetRes := A;
  END;
BEGIN
  FOR I := 1 TO Length(St) DO
    St[I] := Chr( Ord(St[I]) XOR (Ord(St[0])+150+RetRes));
  Code := St;
END;

PROCEDURE ReadDatabase;
VAR
  CVFile: Text;
  CVData: STRING;
  S1,S2 : STRING;
  I1,I2 : Integer;
  I     : Byte;

BEGIN
  Assign(CVFile,FileName);
  {$I-}
    Reset(CVFile);
  {$I+}
  IF IOResult <> 0 THEN
  BEGIN
    Writeln('Error opening '+FileName);
    Halt(2);
  END;
  Readln(CVFile,CVData);
  IF CVData <> 'CHEAT VIEWER FILE' THEN
  BEGIN
    Writeln(FileName+' is not CHEAT VIEWER file');
    Close(CVFile);
    Halt(3);
  END;
  MaxLines := 0;
  Database := New(PCollection, Init(1,1));
  REPEAT
    Readln(CVFile,CVData);
    CVData := Code(CVData);
    IF CVData = '-=This is the end=-' THEN Break;
    S1     := ExtractWords(1,1,CVData);
    S2     := ExtractWords(3,1,CVData);
    CVData := ExtractWords(2,1,CVData);
    I1     := StrToInt(S1);
    I2     := StrToInt(S2);
    IF I1+I2 > MaxLines THEN MaxLines := I1+I2;
    FOR I := 1 TO Length(CVData) DO
      IF CVData[I] = '^' THEN CVData[I] := ' ';
    Database^.Insert(New(PCheat,Init(CVData,I1,I2)));
  UNTIL True = False;
  Close(CVFile);
END;

VAR
  TopicName,
  TopicFile  : STRING[40];
  TimeToQuit : Boolean;

PROCEDURE EditField(VAR InStr: STRING; XPos,YPos,FieldLength: Byte);
LABEL Next;
VAR
  Key     : Word;
  TempStr : STRING;
  TempCPos: Byte;

  PROCEDURE UpdateField(Attr: Byte);
  BEGIN
    FastWrite(XPos,YPos,Attr,TempStr+Replicate(FieldLength-Length(TempStr),' '));
  END;

BEGIN
  TempStr  := InStr;
  TempCPos := Length(TempStr);
  PosCursor(XPos+TempCPos,YPos);
  UpdateField($0F);
  REPEAT
    Key := GetKey;
    CASE Key OF
       kbLeft: IF TempCPos <> 0 THEN Dec(TempCPos);
      kbRight: IF TempCPos <> Length(TempStr) THEN Inc(TempCPos);
       kbHome: TempCPos := 0;
        kbEnd: TempCPos := Length(TempStr);
      46..126,
      kbSpace: IF Length(TempStr)<FieldLength THEN
               BEGIN
                 IF (TempCPos = 0) AND (Key IN [97..122]) THEN Dec(Key,32);
                 IF (TempStr[TempCPos] = ' ') AND (Key IN [97..122]) THEN Dec(Key,32);
                 IF (Ord(TempStr[TempCPos]) IN [48..57]) AND (Key IN [97..122]) THEN Dec(Key,32);
                 Insert(Chr(Key),TempStr,TempCPos+1);
                 Inc(TempCPos);
              END;
kbCtrlBSpace: BEGIN TempStr := ''; TempCPos:= 0; END;
    kbBSpace: IF TempCPos <> 0 THEN
                BEGIN Delete(TempStr,TempCPos,1); Dec(TempCPos); END;
       kbDel: BEGIN Delete(TempStr,TempCPos+1,1); END;
    END;
    PosCursor(XPos+TempCPos,YPos);
    UpdateField($0F);
  UNTIL (Key=kbEnter) OR (Key=kbEsc);
  TempStr := StripBoth(TempStr,' ');
  IF Key = kbEsc THEN TempStr := InStr ELSE InStr := TempStr;
  UpdateField($07);
END;

PROCEDURE WriteData(TopicName,TopicFile: STRING);
VAR F1,F2   : FILE;
    S       : STRING;
    TFile   : Text;
    TBuffer : Pointer;
    AddLines: Word;

  PROCEDURE WriteNDX;
  VAR I,R: Word; Cheat: PCheat; T: STRING;
  BEGIN
    Writeln(TFile,'CHEAT VIEWER FILE');
    FOR I := 0 TO Database^.Count-1 DO
    BEGIN
      S     := '';
      Cheat := Database^.At(i);
      Str(Cheat^.Line,T);
      S := T+' ';
      T := Cheat^.Name^;
      FOR R := 1 TO Length(T) DO IF T[R] = ' ' THEN T[R] := '^';
      S := S+T+' ';
      Str(Cheat^.LNum,T);
      S := S+T;
      Writeln(TFile,Code(S));
    END;
    Writeln(TFile,Code('-=This is the end=-'));
  END;

  PROCEDURE WriteData;
  VAR I: Word; TF: Text;
  BEGIN
    Assign(TF,FileName);
    Reset(TF);
    FOR I := 1 TO Database^.Count+1 DO Readln(TF); { SKIP Index }
    WHILE NOT Eof(TF) DO
    BEGIN
      Readln(TF,S);
      Writeln(TFile,S);
    END;
    Close(TF);
  END;

  PROCEDURE Add;
  VAR TF,Cur: Text; S: STRING;
  BEGIN
    Assign(TF,TopicFile); Reset(TF);
    Assign(Cur,FileName); Append(Cur);
    AddLines := 0;
    WHILE NOT Eof(TF) DO
    BEGIN
      Readln(TF,S); Writeln(Cur,Code(S));
      Inc(AddLines);
    END;
    Close(TF); Close(Cur);
  END;


BEGIN
  IF NOT Exist(TopicFile) THEN Exit;
  Assign(TFile,'$TEMP$.$$$');  Rewrite(TFile);
  GetMem(TBuffer,65535);       SetTextBuf(TFile,TBuffer^,65535);
  Add;
  Database^.Insert(New(PCheat,Init(TopicName,MaxLines,AddLines)));
  WriteNDX;
  WriteData;
  Close(TFile);
  FreeMem(TBuffer,65535);
  Assign(F1,FileName);      Erase(F1);
  Assign(F2,'$TEMP$.$$$');  Rename(F2,FileName);
  Inc(MaxLines, AddLines);
END;

PROCEDURE TheEnd;
BEGIN
  RmWin;
  RmWin;
  Writeln;
  SetBlink(True);
  Cursor(On);
  SetPal(OrgPal);
  Halt;
END;

PROCEDURE GetInfo;
BEGIN
  TopicName := '';
  TopicFile := '';
  Cursor(On);
  MkWin(14,MaxY DIV 2-3,53,9,$5D,Single1,'');
  FastWrite(33,MaxY DIV 2-1,$5E,'ENTER CHEAT NAME');
  FastWrite(19,MaxY DIV 2+1,$07,'[ '+Replicate(40,' ')+' ]');
  FastWrite(29,MaxY DIV 2+3,$5E,'CURRENT DATAFILE:');
  FastWrite(47,MaxY DIV 2+3,$5F,NameOnly(FileName));
  EditField(TopicName,21,MaxY DIV 2+1,40);
  Cursor(Off);
  RmWin;
  IF TopicName = '' THEN
  BEGIN
    Dispose(Database, Done);
    TheEnd;
  END;
END;

PROCEDURE NewFile;
VAR TFile: Text;
BEGIN
  IF Exist('NEWFILE.GCF') THEN
  BEGIN
    Writeln;
    Writeln('NEWFILE.GCF already exist!');
    Halt(0);
  END;
  Assign(TFile,'NEWFILE.GCF');
  Rewrite(TFile);
  Writeln(TFile,'CHEAT VIEWER FILE');
  Writeln(TFile,Code('1 -=^READ^THIS^=- 7'));
  Writeln(TFile,Code('-=This is the end=-'));
  Writeln(TFile);
  Writeln(TFile);
  Writeln(TFile,Code(PadCenter('CHEAT VIEWER Version 1.0 ',78,' ')));
  Writeln(TFile,Code(PadCenter('Copyright (C) 1996 By The GodFather',78,' ')));
  Writeln(TFile);
  Writeln(TFile);
  Writeln(TFile,Code(PadCenter('That''s it for now. Enjoy !!!',78,' ')));
  Close(TFile);
  Writeln;
  Writeln('NEWFILE.GCF is created!');
END;

BEGIN
  IF AdjCase(Upper,ParamStr(1)) = '/N' THEN
  BEGIN
    NewFile;
    Halt;
  END;
  SetPal(AltPal);
  Cursor(Off);
  SetBlink(False);
  MkWin(10,1,60,2,$19,Single1, '');
  WriteBetween(10,70,2,$1E,'ADD CHEAT Version 1.0 By The GodFather');
  IF FileDialog('*.GCF',' Open Datafile ')
    THEN FileName := FileDialogName
    ELSE TheEnd;
  ReadDatabase;
  TimeToQuit := False;
  GetInfo;
  IF FileDialog('*.*',' Add text file ')
    THEN BEGIN
           TopicFile := FileDialogName;
           WriteData(TopicName,TopicFile);
         END;
  Dispose(Database, Done);
  TheEnd;
END.
